FENCE_AGENT(8)

NAME
fence_mpath - Fence agent for multipath persistent reservation

DESCRIPTION

fence_mpath is an I/O Fencing agent that uses SCSI-3 persistent reservations to control access multipath devices. Underlying devices must support SCSI-3 persistent reservations (SPC-3 or greater) as well as the "preempt-and-abort" subcommand. The fence_mpath agent works by having a unique key for each node that has to be set in /etc/multipath.conf. Once registered, a single node will become the reservation holder by creating a "write exclusive, registrants only" reservation on the device(s). The result is that only registered nodes may write to the device(s). When a node failure occurs, the fence_mpath agent will remove the key belonging to the failed node from the device(s). The failed node will no longer be able to write to the device(s). A manual reboot is required.

When used as a watchdog device you can define e.g. retry=1, retry-sleep=2 and verbose=yes parameters in /etc/sysconfig/stonith if you have issues with it failing.

The fence agent accepts options on the command line as well as from stdin. Fenced sends parameters through stdin when it execs the agent. The agent can be run by itself with command line options. This is useful for testing and for turning outlets on or off from scripts.

Vendor URL: https://www.sourceware.org/dm/

PARAMETERS

-o, --action=[action]
    Fencing action (Default Value: off)

-d, --devices=[devices]
    List of devices to use for current operation. Devices can be comma or space separated list of device-mapper multipath devices (eg. /dev/mapper/3600508b400105df70000e00000ac0000 or /dev/mapper/mpath1). Each device must support SCSI-3 persistent reservations.

-k, --key=[key]
    Replaced by port/-n/--plug

-n, --plug=[key]
    Key to use for the current operation. This key should be unique to a node and have to be written in /etc/multipath.conf. For the "on" action, the key specifies the key use to register the local node. For the "off" action, this key specifies the key to be removed from the device(s).

--suppress-errors
    Error log suppression.

-q, --quiet
    Disable logging to stderr. Does not affect --verbose or --debug-file or logging to syslog.

-v, --verbose
    Verbose mode. Multiple -v flags can be stacked on the command line (e.g., -vvv) to increase verbosity.

--verbose-level
    Level of debugging detail in output. Defaults to the number of --verbose flags specified on the command line, or to 1 if verbose=1 in a stonith device configuration (i.e., on stdin).

-D, --debug-file=[debugfile]
    Write debug information to given file

-V, --version
    Display version information and exit

-h, --help
    Display help and exit

--plug-separator=[char]
    Separator for plug parameter when specifying more than 1 plug (Default Value: ,)

--delay=[seconds]
    Wait X seconds before fencing is started (Default Value: 0)

--disable-timeout=[true/false]
    Disable timeout (true/false) (default: true when run from Pacemaker 2.0+)

--login-timeout=[seconds]
    Wait X seconds for cmd prompt after login (Default Value: 5)

--mpathpersist-path=[path]
    Path to mpathpersist binary (Default Value: /usr/sbin/mpathpersist)

--power-timeout=[seconds]
    Test X seconds for status change after ON/OFF (Default Value: 20)

--power-wait=[seconds]
    Wait X seconds after issuing ON/OFF (Default Value: 0)

--shell-timeout=[seconds]
    Wait X seconds for cmd prompt after issuing command (Default Value: 3)

--stonith-status-sleep=[seconds]
    Sleep X seconds between status calls during a STONITH action (Default Value: 1)

--store-path=[path]
    Path to directory where fence agent can store information (Default Value: /var/run/cluster)

--retry-on=[attempts]
    Count of attempts to retry power on (Default Value: 1)

--use-sudo
    Use sudo (without password) when calling 3rd party software

--sudo-path=[path]
    Path to sudo binary (Default Value: /usr/bin/sudo)

ACTIONS

on  Power on machine.

off Power off machine.

status
    This returns the status of the plug/virtual machine.

monitor
    Check the health of fence device

metadata
    Display the XML metadata describing this resource.

manpage
     The operational behavior of this is not known.

validate-all
    Validate if all required parameters are entered.

STDIN PARAMETERS

action
    Fencing action (Default Value: off)

devices
    List of devices to use for current operation. Devices can be comma or space separated list of device-mapper multipath devices (eg. /dev/mapper/3600508b400105df70000e00000ac0000 or /dev/mapper/mpath1). Each device must support SCSI-3 persistent reservations.

key Replaced by port/-n/--plug

plug
    Key to use for the current operation. This key should be unique to a node and have to be written in /etc/multipath.conf. For the "on" action, the key specifies the key use to register the local node. For the "off" action, this key specifies the key to be removed from the device(s). Obsoletes: port

suppress_errors
    Error log suppression. Obsoletes: suppress-errors

quiet
    Disable logging to stderr. Does not affect --verbose or --debug-file or logging to syslog.

verbose
    Verbose mode. Multiple -v flags can be stacked on the command line (e.g., -vvv) to increase verbosity.

verbose_level
    Level of debugging detail in output. Defaults to the number of --verbose flags specified on the command line, or to 1 if verbose=1 in a stonith device configuration (i.e., on stdin).

debug_file
    Write debug information to given file Obsoletes: debug

version
    Display version information and exit

help
    Display help and exit

plug_separator
    Separator for plug parameter when specifying more than 1 plug (Default Value: ,)

delay
    Wait X seconds before fencing is started (Default Value: 0)

disable_timeout
    Disable timeout (true/false) (default: true when run from Pacemaker 2.0+)

login_timeout
    Wait X seconds for cmd prompt after login (Default Value: 5)

mpathpersist_path
    Path to mpathpersist binary (Default Value: /usr/sbin/mpathpersist)

power_timeout
    Test X seconds for status change after ON/OFF (Default Value: 20)

power_wait
    Wait X seconds after issuing ON/OFF (Default Value: 0)

shell_timeout
    Wait X seconds for cmd prompt after issuing command (Default Value: 3)

stonith_status_sleep
    Sleep X seconds between status calls during a STONITH action (Default Value: 1)

store_path
    Path to directory where fence agent can store information (Default Value: /var/run/cluster)

retry_on
    Count of attempts to retry power on (Default Value: 1)

use_sudo
    Use sudo (without password) when calling 3rd party software Obsoletes: sudo

sudo_path
    Path to sudo binary (Default Value: /usr/bin/sudo)